#!/usr/bin/env perl

# check known answer tests

my $failed = 0;
my $passed = 0;
my $total = 0;
my $files  = 0;
my $tfiles = 0;

$| = 1;

sub trial {
  my ($file, $count, $invoke) = @_;
  my $out = `$invoke 2>&1`;
  if ($out =~ /\S/) {
    print STDERR "\n\nIn file $file, count $count:\n$invoke\n$out\n\n";
    $failed = $failed + 1;
  } else {
    $passed = $passed + 1;
  }
  $total = $total + 1;
}

foreach my $file (@ARGV) {
  my $invoke;
  print "\n" if ($tfiles % 50 == 0 && $tfiles != 0);
  $tfiles = $tfiles + 1;
  if ($file =~ /^(?:.*\/)*(CBC|CFB(?!1[^2])|ECB|OFB)/) {
    $mode = $1;
    $files ++;
    print "*";
  } else {
    print "-";
    next;
  }
  
  open FILE, "<$file";
  $txt = join '', <FILE>;
  close FILE;
  
  while ($txt =~ s/
    COUNT\ =\ (\d+)\s+
    KEY\ =\ ([a-f0-9]+)\s+
    (?:IV\ =\ ([a-f0-9]+)\s+)?
    CIPHERTEXT\ =\ ([a-f0-9]+)\s+
    PLAINTEXT\ =\ ([a-f0-9]+)\s+//ix) {
    my $iv = '';
    $iv = "-I $3" if (defined $3 && $3 ne '');
      
    trial($file, $1, "./test -m $mode -K $2 $iv -i $4 -o $5 -d");
  }
  
    while ($txt =~ s/
    COUNT\ =\ (\d+)\s+
    KEY\ =\ ([a-f0-9]+)\s+
    (?:IV\ =\ ([a-f0-9]+)\s+)?
    PLAINTEXT\ =\ ([a-f0-9]+)\s+
    CIPHERTEXT\ =\ ([a-f0-9]+)\s+//ix) {
    my $iv = '';
    $iv = "-I $3" if (defined $3 && $3 ne '');
      
    trial($file, $1, "./test -m $mode -K $2 $iv -i $4 -o $5");
  }
  
}

if ($failed) {
  print "\nPassed $passed / $total tests in $files / $tfiles files\n";
} elsif ($passed) {
  print "\nPassed all $passed tests in $files / $tfiles files\n";
} else {
  print "\nNo tests found in $files / $tfiles files\n";
}
