#!/bin/sh

# miscellaneous tests

make >/dev/null || exit

# warn if any sensitive  register gets pushed onto the stack
perl -ne 'if (/mov.*xmm.*rsp/) { 
            print STDERR "verify: warning: $_"; 
          }' \
    ../aes_core.s ../aes.s

# sanity-check modes and padding
for k in 128 192 256; do
    for mode in ecb cbc; do
	for pad in null des pkcs5; do
	    for i in `seq 1 50`; do
		./test -s $i -k $k -m $mode -p $pad
	    done
	done
	
	# ciphertext stealing
	for i in `seq 16 50`; do
	    ./test -s $i -k $k -m $mode -p cts
	done
    done

    for mode in ctr ctr64 ofb cfb; do
	for i in `seq 1 50`; do
	    ./test -s $i -k $k -m $mode
	done
    done
done
